#include "mbed.h"
#include "sdram.h"
#include "USBSerial.h"

DigitalOut led1(LED1);
USBSerial cdc;
Serial pc(USBTX,USBRX);

#define SIZE (1024*1024)

int alloccount = 0;
unsigned char *ptr[100] ;

int main() {
    sdram_init();
    while(1) {
        ptr[alloccount] = (unsigned char *)malloc(SIZE) ;
        cdc.printf ("Allocated Address = %08X\r\n",ptr[alloccount]);
        pc.printf ("Allocated Address = %08X\r\n",ptr[alloccount]);
        if (ptr[alloccount] == NULL) {
            cdc.printf("MAX ALLOC MEMORY %d MB\r\n",alloccount);
            pc.printf("MAX ALLOC MEMORY %d MB\r\n",alloccount);
            for (int i=0;i<alloccount;i++) {
                free(ptr[i]);
            }
            alloccount = 0;
        } else {
            alloccount++ ;
        }
        led1 = 1;
        wait(0.1);
        led1 = 0;
        wait(0.1);
    }
}
